<?php
/*
Plugin Name: iRate
Version: 0.4.6
Plugin URI: http://www.sebaxtian.com/acerca-de/irate
Description: your iRateMyDay's last rate.
Author: Juan Sebastián Echeverry
Author URI: http://www.sebaxtian.com/
*/

/* Copyright 2007-2008 Juan Sebastián Echeverry (email : sebaxtian@gawab.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

define('IRATE_CACHE_AGE', 600); //Elapsed time to update cache (10 minutes)

add_action('init', 'irate_textdomain');

function irate_textdomain() {
	load_plugin_textdomain('irate', 'wp-content/plugins/irate/lang');
}

/**
	* Function to update cache if the time elapsed is older than the defined one.
	*
	* @access public
	*/

function irate_update( ) {
	$update=true;
	$options = get_option('widget_irate');
	if($options['timestamp']=='') {
		$update=true;
	} else {
		if($options['timestamp']+IRATE_CACHE_AGE>time()) {
			$update=false;
		}
	}
	if($update) {
		$options['timestamp']=time();
		if($data = mnmx_readfile('http://api.iratemyday.com/User.aspx?u='.$options['username'])) {
			$user = new SimpleXMLElement($data);
			$options['imageurl']=(string) $user->user->imageUrl;
		}
		if($data = mnmx_readfile('http://api.iratemyday.com/RatingList.aspx?u='.$options['username'])) {
			$rate = new SimpleXMLElement($data);
			$options['comment']=(string) $rate->ratingList->rating[0]->comment;
			$options['readurl']=(string) $rate->ratingList->rating[0]->readUrl;
		}
		update_option('widget_irate', $options);
	}
}

/**
	* Returns the HTML to show the rate in cache.
	*
	* @return string
	* @access public
	*/

function irate_contents( ) {
	$options = get_option('widget_irate');
	$answer = "<table><tr><td valign='top'><a href='http://www.iratemyday.com'><img src='".$options['imageurl']."' border='0' align='left' alt=''/></a></td><td>".$options['comment']." [<a href='".$options['readurl']."'>".__('Comments', 'irate')."</a>]</td></tr></table>";
	return $answer;
}

// irate widget stuff
function widget_irate_init() {

	if ( !function_exists('register_sidebar_widget') )
		return;

	function widget_irate($args) {

		// $args is an array of strings that help widgets to conform to
		// the active theme: before_widget, before_title, after_widget,
		// and after_title are the array keys. Default tags: li and h2.
		extract($args);
	
		// Each widget can store its own options. We keep strings here.
		$options = get_option('widget_irate');
		$title = $options['title'];
	
		// These lines generate our output. Widgets can be very complex
		// but as you can see here, they can also be very, very simple.
		echo $before_widget . $before_title . $title . $after_title;
// 		require('irate_ajax.php');
		$url=get_bloginfo('wpurl').'/wp-content/plugins/irate/content.php';
		if(function_exists('minimax') && minimax_version()==0.2 ) {
		echo "<div id='irate_content'><table><tr><td><img src='".get_bloginfo('wpurl')."/wp-content/plugins/irate/img/loading.gif' alt='RSS' border='0' /></td><td>".__('Loading iRate...','irate')."</td></tr></table></div><script type='text/javascript'>
				var mx_irate = new minimax('$url', 'irate_content'); 
				mx_irate.get();</script>";
		} else {
			echo "<div id='irate_content'>".sprintf(__('You have to install <a href="%s"  target="_BLANK">minimax 0.2</a> in order for this plugin to work', 'irate'), "http://wordpress.org/extend/plugins/minimax/" )."</div>";
		}
		echo $after_widget;
	}
	
	// This is the function that outputs the form to let the users edit
	// the widget's title. It's an optional feature that users cry for.
	function widget_irate_control() {
	
		// Get our options and see if we're handling a form submission.
		$options = get_option('widget_irate');
		if ( !is_array($options) )
			$options = array('title'=>'', 'username'=>'', 'timestamp'=>'', 'imageurl'=>'', 'comment'=>'', 'readurl'=>'');
		if ( $_POST['irate-submit'] ) {
			// Remember to sanitize and format use input appropriately.
			$options['title'] = strip_tags(stripslashes($_POST['irate_title']));
			$options['username'] = strip_tags(stripslashes($_POST['irate_username']));	
			$options['timestamp']==time()-IRATE_CACHE_AGE-1;
			update_option('widget_irate', $options); 
			irate_update();
		}

		// Be sure you format your options to be valid HTML attributes.
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$username = htmlspecialchars($options['username'], ENT_QUOTES);
		$timestamp = $options['timestamp'];

 
		// Here is our little form segment. Notice that we don't need a
		// complete form. This will be embedded into the existing form.
		require('irate_widget.php');
	}
	
	// This registers our widget so it appears with the other available
	// widgets and can be dragged and dropped into any active sidebars.
	register_sidebar_widget(array('iRate', 'widgets'), 'widget_irate');
	
	// This registers our optional widget control form. Because of this
	// our widget will have a button that reveals a 300x100 pixel form.
	register_widget_control(array('irate', 'widgets'), 'widget_irate_control');
}

// Run our code later in case this loads prior to any required plugins.
add_action('widgets_init', 'widget_irate_init');

?>